;; marks.jl - Provide a way to operate on multiple windows
;;
;; Author : Yann Hodique <Yann.Hodique@lifl.fr>

(defvar marked-windows-list nil)

(defun mark-window (win)
  (setq marked-windows-list (append marked-windows-list (list win))))

(define-command 'mark-window mark-window #:spec "%W")

(defun unmark-window (win)
  (setq marked-windows-list (remove win marked-windows-list)))

(define-command 'unmark-window unmark-window #:spec "%W")

(defun unmark-all-windows ()
  (setq marked-windows-list nil))

(define-command 'unmark-all-windows unmark-all-windows)

(defun apply-on-marked-windows (func)
  (mapcar func marked-windows-list))

(defun marked-windows ()
  (not (eq marked-windows-list nil)))

(provide 'marks)
